package com.s_cradle.improve.client;

import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.StringItem;
import com.s_cradle.improve.Constants;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * {ltH[JX Menu łB
 *
 * @author Masaru Yoshimura
 */
public class MainMenu extends Menu implements CommandListener{
    private static final String PRE_TITLE = "ƭ:";
    private static final String[] ITEMS = {"ðς",
        "ð","FB","̨","E","IMI","LZ"};

    private static final int ITEM_CHENGE_STATUS = 0;
    private static final int ITEM_WRITE_IN_STATUS = 1;
    private static final int ITEM_ADD_FRIEND = 2;
    private static final int ITEM_PROFILE = 3;
    private static final int ITEM_WITHDRAW = 4; //E
    private static final int ITEM_END_IM = 5;
    private static final int ITEM_CANCEL = 6;

    private TextField nicknameTextField;
    private TextField phoneNumberTextField;
    private Buddy buddy;

    /**
     * RXgN^
     */
    public MainMenu(Buddy buddy_) {
        super(PRE_TITLE+buddy_.getNickname(),ITEMS);
        buddy = buddy_;
    }

    /**
     * L[nh
     */
    protected Menu processFireKeyRelease(){
        //System.out.println("cursor:"+cursor);
        TextBox textBox;

        switch(cursor){
            case ITEM_CHENGE_STATUS:
                return new ChangeStatusMenu();
            case ITEM_WRITE_IN_STATUS:
                textBox = new TextBox(buddy.getNickname()+":ð",
                        buddy.getDescription(),Constants.DESCRIPTION_MAX,TextField.ANY);
                textBox.setCommandListener(this);
                textBox.addCommand(okCommand);
                textBox.addCommand(cancelCommand);
                ImproveMIDlet.setCurrent(textBox);
                return null;
            case ITEM_ADD_FRIEND:
                textBox = new TextBox("FBǉ","",Constants.ACCOUNT_MAX,TextField.EMAILADDR);
                textBox.setCommandListener(this);
                textBox.addCommand(okCommand);
                textBox.addCommand(cancelCommand);
                ImproveMIDlet.setCurrent(textBox);
                return null;
            case ITEM_PROFILE:
                Item[] items = new Item[]{
                    new StringItem(": ",buddy.getAccount()),
                    nicknameTextField = new TextField("ƯȰ: ",buddy.getNickname(),Constants.NICKNAME_MAX,TextField.ANY),
                    phoneNumberTextField = new TextField("dbԍ: ",buddy.getPhoneNumber(),Constants.PHONENUMBER_MAX,TextField.PHONENUMBER)
                };
                Form form = new Form("̨",items);
                form.addCommand(okCommand);
                form.addCommand(cancelCommand);
                form.setCommandListener(this);
                ImproveMIDlet.setCurrent(form);
                return null;
            case ITEM_WITHDRAW:
                return new TwoChoiceMenu("މ܂H",TwoChoiceMenu.MENU_WITHDRAW);
            case ITEM_END_IM:
                return new TwoChoiceMenu("I܂H",TwoChoiceMenu.MENU_QUIT);
            case ITEM_CANCEL:
            default:
                break;
        }

        return null;
    }

    /**
     * CommandListener
     */
    public void commandAction(Command c, Displayable d){
        Task task, task2;
        if( c.equals(cancelCommand) ){
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
        } else if( c.equals(okCommand) ){
            switch(cursor){
                case ITEM_WRITE_IN_STATUS:
                    task = Task.getTask(Task.TASK_SET,new String[]{
                                String.valueOf(Constants.ITEM_INDEX_DESCRIPTION),
                                ((TextBox)d).getString()});
                    task.schedule(0);
                    ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
                    break;
                case ITEM_ADD_FRIEND:
                    task = Task.getTask(
                            Task.TASK_ADD,new String[]{((TextBox)d).getString()});
                    task.schedule(0);
                    break;
                case ITEM_PROFILE:
                    task = Task.getTask(Task.TASK_SET,new String[]{
                                String.valueOf(Constants.ITEM_INDEX_NICKNAME),
                                nicknameTextField.getString()});
                    task.schedule(0);
                    task2 = Task.getTask(Task.TASK_SET,new String[]{
                                String.valueOf(Constants.ITEM_INDEX_PHONE),
                                phoneNumberTextField.getString()});
                    task2.schedule(0);
                    break;
            }
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
        }
    }
}