package com.s_cradle.improve.client;

import javax.microedition.lcdui.Image;
import javax.microedition.rms.*;
import java.io.IOException;
import java.util.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * RecordStrore  Image ǗNXłB
 *
 * @author Masaru Yoshimura
 */
public class ResourceManager {
    // 摜̃TCY
    public static final int IMAGE_WIDTH = 16;
    public static final int IMAGE_HEIGHT = 16;

    // 摜ID
    public static final int IMAGE_UP = 0;
    public static final int IMAGE_DOWN = 1;
    public static final int IMAGE_RIGHT = 2;
    public static final int IMAGE_LEFT = 3;
    public static final int IMAGE_NORMAL_GREEN = 4;
    public static final int IMAGE_NORMAL_YELLOW = 5;
    public static final int IMAGE_NORMAL_RED = 6;
    public static final int IMAGE_NORMAL_OFF = 7;
    public static final int IMAGE_SELECT_GREEN = 8;
    public static final int IMAGE_SELECT_YELLOW = 9;
    public static final int IMAGE_SELECT_RED = 10;
    public static final int IMAGE_SELECT_OFF = 11;

    // 摜̖O
    private static final String FILE_UP = "/arrow_up.png";
    private static final String FILE_DOWN = "/arrow_down.png";
    private static final String FILE_RIGHT = "/arrow_right.png";
    private static final String FILE_LEFT = "/arrow_left.png";
    private static final String FILE_NORMAL_GREEN = "/normal_green.png";
    private static final String FILE_NORMAL_YELLOW = "/normal_yellow.png";
    private static final String FILE_NORMAL_RED = "/normal_red.png";
    private static final String FILE_NORMAL_OFF = "/normal_off.png";
    private static final String FILE_SELECT_GREEN = "/select_green.png";
    private static final String FILE_SELECT_YELLOW = "/select_yellow.png";
    private static final String FILE_SELECT_RED = "/select_red.png";
    private static final String FILE_SELECT_OFF = "/select_off.png";

    // R[hXgA
    private static final String RECORDSTORE_NAME_ACCOUNT = "account";
    private static final String RECORDSTORE_NAME_PASSWORD = "password";

    private static Image[] images;

    /**
     * 摜̎擾
     */
    public static Image getImage(int num){
        return images[num];
    }

    /**
     * R[hXgAAJEgƃpX[hǂݍTaskɐݒ肷B
     */
    public static String getAccountAndPasswordFromRecordStore(){
        String ret = null;

        RecordStore rs = null;
        try{
            rs = RecordStore.openRecordStore(RECORDSTORE_NAME_ACCOUNT,true);
            RecordEnumeration re = rs.enumerateRecords(null,null,true);
            Task.setAccount(new String(re.nextRecord()));
            Task.setPassword(new String(re.nextRecord()));
        } catch(RecordStoreException ex) {
            Task.setAccount(null);
            Task.setPassword(null);
        } finally{
            if(rs != null){
                try{
                    rs.closeRecordStore();
                } catch(RecordStoreException ex){
                    //NOP
                }
            }
        }
        return null;
    }

    /**
     * TaskAJEgƃpX[h擾AR[hXgAɏށB
     */
    public static void setAccountAndPasswordToRecordStore(){
        String account = Task.getAccount();
        String password = Task.getPassword();
        RecordStore rs = null;
        Vector tempVec = new Vector();
        int id;

        try{
            rs = RecordStore.openRecordStore(RECORDSTORE_NAME_ACCOUNT,true);
            RecordEnumeration re = rs.enumerateRecords(null,null,true);
            while( re.hasNextElement() ){
                id = re.nextRecordId();
                tempVec.addElement(new Integer(id));
            }
            for(Enumeration e=tempVec.elements();e.hasMoreElements();){
                rs.deleteRecord(((Integer)e.nextElement()).intValue());
            }
        } catch(RecordStoreException ex) {
            //NOP
        } finally{
            if(rs != null){
                try{
                    rs.closeRecordStore();
                } catch(RecordStoreException ex){
                    //NOP
                }
            }
        }

        try{
            rs = RecordStore.openRecordStore(RECORDSTORE_NAME_ACCOUNT,true);
            save(rs,account.getBytes());
            save(rs,password.getBytes());
        } catch(RecordStoreException ex) {
            //NOP
        } finally{
            if(rs != null){
                try{
                    rs.closeRecordStore();
                } catch(RecordStoreException ex){
                    //NOP
                }
            }
        }
    }

    /**
     * ۑ܂B
     */
    private static int save(RecordStore rs, byte[] data) throws RecordStoreException{
        return rs.addRecord(data,0,data.length);
    }

    static{
        try{
            images = new Image[]{
                Image.createImage(FILE_UP),
                Image.createImage(FILE_DOWN),
                Image.createImage(FILE_RIGHT),
                Image.createImage(FILE_LEFT),
                Image.createImage(FILE_NORMAL_GREEN),
                Image.createImage(FILE_NORMAL_YELLOW),
                Image.createImage(FILE_NORMAL_RED),
                Image.createImage(FILE_NORMAL_OFF),
                Image.createImage(FILE_SELECT_GREEN),
                Image.createImage(FILE_SELECT_YELLOW),
                Image.createImage(FILE_SELECT_RED),
                Image.createImage(FILE_SELECT_OFF),
            };
        } catch(IOException ex){
            System.out.println("IOException in ResourceManager");
            //NOP
        }
    }

}