package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * eIy[V̂߂̒ۃNXłB
 *
 * @author Itaru Ogawa
 */
public abstract class Operation {
    private static Hashtable operationTable;

    /** eIy[V̉߂p[^[z܂B */
    protected String[] parameters;

    static {
        operationTable = new Hashtable();
        operationTable.put(Constants.OPERATION_CREATE, new Create());
        operationTable.put(Constants.OPERATION_DELETE, new Delete());
        operationTable.put(Constants.OPERATION_ADD, new Add());
        operationTable.put(Constants.OPERATION_REMOVE, new Remove());
        operationTable.put(Constants.OPERATION_SET, new Set());
        operationTable.put(Constants.OPERATION_SEND, new Send());
        operationTable.put(Constants.OPERATION_POLLING, new Polling());
        operationTable.put(Constants.OPERATION_TEST, new Test());
        operationTable.put(Constants.OPERATION_CHECK, new Check());
    }


    /**
     * pXeIy[VCX^XԂ܂B
     * p[^[checkɍss̏ꍇ͂p̃Iy[V
     * Ԃ܂B
     */
    public static Operation getOperation(HttpServletRequest req) {
        String path = req.getPathInfo();

        if (path==null) {
            path = Constants.OPERATION_CHECK;
        }

        Operation operation = (Operation)operationTable.get(path);

        if (operation == null) {
            operation = new ErrorOperation("Iy[V܂B path = "+path);
        }

        ImproveServlet.out.println("operation = "+path);

        String shortParams = operation.checkParameters(req);

        if (shortParams!=null) {
            operation = new ErrorOperation(" p[^[sĂ܂B "+shortParams);
        }
        return operation;
    }

    /**
     * parametersɒ`Ăp[^[Ǝ󂯎p[^r܂B
     *
     * @retrun null ̎Bs͕sp[^[
     */
    protected String checkParameters(HttpServletRequest req) {
        StringBuffer buf = new StringBuffer();
        for (int i=0; i<parameters.length; i++) {
            System.out.println(parameters[i]);
            if (req.getParameter(parameters[i])==null) {
                buf.append(parameters[i]).append(" ");
            }
        }
        if (buf.length() == 0) {
            return null;
        } else {
            return buf.toString();
        }
    }

    /**
     * [U[Fؗp̃\bhłB
     * f[^x[XɃAJEgƃpX[hv郆[U[邩
     * ǂf܂B
     */
    protected boolean isAuthorized(String account, String password) {
        ImproveServlet.out.println(" called isAuthorized");
        ImproveServlet.out.println("  account  = "+account);
        ImproveServlet.out.println("  password = "+password);


        Connection con = null;
        Statement st = null;
        String sql;
        boolean ret = false;

        try {
            // JDBChCõ[hƐڑ
            Class.forName(Constants.POSTGRESQL_DRIVER).newInstance();
            con = DriverManager.getConnection(Constants.POSTGRESQL_CONNECTION);

            // [U[F
            ResultSet rs;
            st = con.createStatement();
            sql = "SELECT account FROM users WHERE account='"+account+"' AND "
                +"password='"+password+"'";
            rs = st.executeQuery(sql);
            ImproveServlet.out.println("  executeQuery : "+sql);
            ret = rs.next() && rs.isLast(); // Bꑶ݂̂Ƃtrue
            st.close();

            con.close();
            st = null;
            con = null;

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            ImproveServlet.out.println("  EXCEPTION : "+sqle);
            ret = false;

        } finally {
            try {
                if (st!=null) {
                    st.close();
                }
                if (con!=null) {
                    con.close();
                }
            } catch (SQLException sqle2) {
                sqle2.printStackTrace();
                ImproveServlet.out.println("  EXCEPTION : "+sqle2);
            }
            ImproveServlet.out.println(" authentification result = "+ret);

            return ret;
        }
    }

    /**
     * eIy[Vp̒`łBGET\bhŃNGXg󂯂̋܂B
     */
    public abstract int processGet(HttpServletRequest req, HttpServletResponse res)
        throws IOException;

    /**
     * eIy[Vp̒`łBPOST\bhŃNGXg󂯂̋܂B
     */
    public abstract int processPost(HttpServletRequest req, HttpServletResponse res)
        throws IOException;
}
